#!/usr/bin/env python
# -*- coding: UTF-8 -*-


import sys
from PyQt4 import QtCore, QtGui

class AboutPage(QtGui.QWidget):
    def __init__(self,livecreatorConfig, parent=None):
        """
            This class defines the about page
        """
        QtGui.QWidget.__init__(self, parent)
        # Main group box
        configGroup = QtGui.QGroupBox(self.tr(_("About LiveCreator")))
        # About Text
        serverLabel = QtGui.QLabel( _("Description: GUI for building Live images.\n\nDate: %(date)s\nVersion : %(version)s \n\nProject initiator: Gendarmerie Nationale (France) / %(linagoraname)s\nProject leader: %(presentleader)s\n\nLicense:") % { 'date' : "2008 - 2009", 'version' : livecreatorConfig.get("main","version"), 'linagoraname' : "LINAGORA Group", 'presentleader' : "Erwan Le Gall (LINAGORA Paris)" } )

        #serverLabel = QtGui.QLabel(abouttxt)
        # License
        licenseFile = QtCore.QFile("LICENSE")
        licenseFile.open(QtCore.QIODevice.ReadOnly)
        text= licenseFile.readData(licenseFile.size())
        text= QtCore.QString.fromUtf8(text)
        licenseEdit =  QtGui.QTextEdit()
        licenseEdit.append(text)
        licenseEdit.setReadOnly(1)
        licenseEdit.scrollToAnchor(" ")
        # Show about page
        configLayout = QtGui.QGridLayout()
        configLayout.addWidget(serverLabel,0,0)
        configLayout.addWidget(licenseEdit,1,0)
        configGroup.setLayout(configLayout)
        mainLayout = QtGui.QGridLayout()
        mainLayout.addWidget(configGroup,0,0,0,12)
        self.setLayout(mainLayout)




#Old artefacts
        #serverLabel = QtGui.QLabel( u"Description : interface d'aide à la réalisation d'images de Lives.\n\nDate : (c) 2008, Les développeurs de LiveCreator\nVersion : %s \n\nInitiation du projet :                      Gendarmerie Nationale France\nResponsable du développement : Erwan Le Gall\nDéveloppement :                           LINAGORA SA\n\nAccord de licence : "%livecreatorConfig.get("main","version")   ) 
