#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import sys
from PyQt4 import QtCore, QtGui



class DescCustomize(QtGui.QWidget):
    def __init__(self,livecreatorConfig, xmlFile, parent=None):
        QtGui.QWidget.__init__(self, parent)
        """
            Tab for human template description
        """
        self.livecreatorConfig = livecreatorConfig
        self.xmlFile = xmlFile



        hostnameLabel = QtGui.QLabel( _("Hostname:") )
        self.hostnameEdit = QtGui.QLineEdit()
        self.hostnameEdit.setDisabled(1)

        usernameLabel = QtGui.QLabel( _("Login: ") )
        self.usernameEdit = QtGui.QLineEdit()
        self.usernameEdit.setDisabled(1)

        langLabel = QtGui.QLabel( _("Language: ") )
        self.langEdit = QtGui.QLineEdit()
        self.langEdit.setDisabled(1)

        kbdLabel = QtGui.QLabel( _("Layout (keyboard): ") )
        self.kbdEdit = QtGui.QLineEdit()
        self.kbdEdit.setDisabled(1)

        typeLabel = QtGui.QLabel( _("Live type: ") )
        self.typeEdit = QtGui.QLineEdit()
        self.typeEdit.setDisabled(1)

        archLabel = QtGui.QLabel( _("Architecture : ") )
        self.archEdit = QtGui.QLineEdit()
        self.archEdit.setDisabled(1)

        imgbootLabel = QtGui.QLabel( _("Loader picture: ") )
        self.imgbootEdit = QtGui.QLineEdit()
        self.imgbootEdit.setDisabled(1)

        cryptLabel = QtGui.QLabel( _("Encryption method: ") )
        self.cryptEdit = QtGui.QLineEdit()
        self.cryptEdit.setDisabled(1)

        timeoutLabel = QtGui.QLabel( _("Timer before boot: ") )
        self.timeoutEdit = QtGui.QLineEdit()
        self.timeoutEdit.setDisabled(1)

        persistentLabel = QtGui.QLabel( _("Persistence: ") )
        self.persistentEdit = QtGui.QLineEdit()
        self.persistentEdit.setDisabled(1)

        automountLabel = QtGui.QLabel( _("Partitions automount: ") )
        self.automountEdit = QtGui.QLineEdit()
        self.automountEdit.setDisabled(1)

        dhcpLabel = QtGui.QLabel( _("Automatic network demand (DHCP): ") )
        self.dhcpEdit = QtGui.QLineEdit()
        self.dhcpEdit.setDisabled(1)

        imgloadLabel = QtGui.QLabel( _("Boot splash picture: ") )
        self.imgloadEdit = QtGui.QLineEdit()
        self.imgloadEdit.setDisabled(1)


        commentaireLabel = QtGui.QLabel( _("Comments: ") )
        self.commentaireEdit = QtGui.QTextEdit()

        mainLayout = QtGui.QGridLayout()
        # generals options
        mainLayout.addWidget(hostnameLabel,0,0)
        mainLayout.addWidget(self.hostnameEdit,0,1,1,2)
        mainLayout.addWidget(usernameLabel,1,0)
        mainLayout.addWidget(self.usernameEdit,1,1,1,2)
        mainLayout.addWidget(langLabel,2,0)
        mainLayout.addWidget(self.langEdit,2,1,1,2)
        mainLayout.addWidget(kbdLabel,3,0)
        mainLayout.addWidget(self.kbdEdit,3,1,1,2)
        mainLayout.addWidget(typeLabel,4,0)
        mainLayout.addWidget(self.typeEdit,4,1,1,2)
        #mainLayout.addWidget(archLabel,5,0)
        #mainLayout.addWidget(self.archEdit,5,1,1,2)
        mainLayout.addWidget(imgbootLabel,6,0)
        mainLayout.addWidget(self.imgbootEdit,6,1,1,2)
        # advanced options
        mainLayout.addWidget(cryptLabel,7,0)
        mainLayout.addWidget(self.cryptEdit,7,1,1,2)
        mainLayout.addWidget(timeoutLabel,8,0)
        mainLayout.addWidget(self.timeoutEdit,8,1,1,2)
        #mainLayout.addWidget(persistentLabel,9,0)
        #mainLayout.addWidget(self.persistentEdit,9,1,1,2)
        mainLayout.addWidget(automountLabel,10,0)
        mainLayout.addWidget(self.automountEdit,10,1,1,2)
        mainLayout.addWidget(dhcpLabel,11,0)
        mainLayout.addWidget(self.dhcpEdit,11,1,1,2)
        mainLayout.addWidget(imgloadLabel,12,0)
        mainLayout.addWidget(self.imgloadEdit,12,1,1,2)
        #mainLayout.addWidget(self.loadFields,13,1,1,2)
        mainLayout.addWidget(commentaireLabel,14,0)
        mainLayout.addWidget(self.commentaireEdit,14,1,1,2)

        #mainLayout.addSpacing(12)
        #mainLayout.addStretch(1)

        self.setLayout(mainLayout)


    def clearDescFields(self):
        self.hostnameEdit.setText( _("Default") )
        self.usernameEdit.setText( _("Default") )
        self.langEdit.setText("")
        self.kbdEdit.setText("")
        self.typeEdit.setText("")
        self.archEdit.setText("")
        self.imgbootEdit.setText( _("Default") )
        self.cryptEdit.setText("")
        self.timeoutEdit.setText( _("Default") )
        self.persistentEdit.setText("")
        self.automountEdit.setText("")
        self.dhcpEdit.setText("")
        self.imgloadEdit.setText( _("Default") )
        self.commentaireEdit.setText("")

    def initFields(self,allOptions):
        """
            Initialize all fields from interface values
        """
        #livecreatorOptions = [ self.hostnameEdit,
                        #self.usernameEdit,
                        #self.langEdit,
                        #self.kbdEdit,
                        #self.typeEdit,
                        #self.imgbootEdit,
                        #self.cryptEdit,
                        #self.timeoutEdit,
                        #self.persistentEdit,
                        #self.automountEdit,
                        #self.dhcpEdit,
                        #self.imgloadEdit]
        #for edit in livecreatorOptions:
            #index = livecreatorOptions.index(edit)
            #if allOptions[index][1] =="":
                #edit.setText(u"Par défaut")
            #else:
                #edit.setText(allOptions[index][1])
        # Hostname
        if allOptions[0][1] == "":
            self.hostnameEdit.setText( _("Default") )
        else :
            self.hostnameEdit.setText(allOptions[0][1])
        # Username
        if allOptions[1][1] == "":
            self.usernameEdit.setText( _("Default") )
        else:
            self.usernameEdit.setText(allOptions[1][1])
        # Lang
        self.langEdit.setText(allOptions[2][1])
        # Kbd
        self.kbdEdit.setText(allOptions[3][1])
        # Live type
        self.typeEdit.setText(allOptions[4][1])
        # boot splash
        if allOptions[5][1] == "":
            self.imgbootEdit.setText( _("Default") )
        else:
            self.imgbootEdit.setText(allOptions[5][1])
        # Encryption
        self.cryptEdit.setText(allOptions[6][1])
        # Timeout
        if allOptions[7][1] == "":
            self.timeoutEdit.setText( _("Default") )
        else:
            self.timeoutEdit.setText(allOptions[7][1])
        # Persistence
        self.persistentEdit.setText(allOptions[8][1])
        # Automount
        self.automountEdit.setText(allOptions[9][1])
        # DHCP
        self.dhcpEdit.setText(allOptions[10][1])
        # load spash
        if allOptions[11][1] == "":
            self.imgloadEdit.setText( _("Default") )
        else:
            self.imgloadEdit.setText(allOptions[11][1])
        # Architecture
        self.archEdit.setText(allOptions[12][1])

    def initDescription(self):
        """
            Initialize all fields from xml file
        """
        # Clear Options
        self.clearDescFields()
        # Text files
        descOptions = { 'desc_hostname' : self.hostnameEdit,
                        'desc_username' : self.usernameEdit,
                        'desc_lang' : self.langEdit,
                        'desc_kbd' : self.kbdEdit,
                        'desc_type' : self.typeEdit,
                        'desc_arch' : self.archEdit,
                        'desc_bootsplash' : self.imgbootEdit,
                        'desc_crypt_level' : self.cryptEdit,
                        'desc_timeout' : self.timeoutEdit,
                        'desc_persistence' : self.persistentEdit,
                        'desc_automount' : self.automountEdit,
                        'desc_dhcp' : self.dhcpEdit,
                        'desc_usplash' : self.imgloadEdit,
                        'desc_comment' : self.commentaireEdit,
                    }
        for key in descOptions.keys():
            descOptions[key].setText( QtCore.QString.fromUtf8(self.xmlFile.getXMLValue(key).encode("iso8859-15") ) )
