#!/usr/bin/env python
# -*- coding: UTF-8 -*-


import sys, shutil, os
from PyQt4 import QtCore, QtGui
from livecreator_misc import functions

class HookCustomize(QtGui.QWidget):
    def __init__(self,livecreatorConfig, xmlFile, parent=None):
        QtGui.QWidget.__init__(self, parent)

        self.livecreatorConfig = livecreatorConfig
        self.xmlFile = xmlFile

        self.livecreatorConfig = livecreatorConfig
        #HOOK postsint
        posthookGroup = QtGui.QGroupBox( _("Personalization scripts, outside chroot") )
        posthooklayout = QtGui.QGridLayout()
        self.posthookList = QtGui.QListWidget()
        postaddHook= QtGui.QPushButton( _("Add") )
        postdelHook= QtGui.QPushButton( _("Delete") )
        posthooklayout.addWidget(self.posthookList,0,1,0,1)
        posthookGroup.setLayout(posthooklayout)

        #HOOK presint
        prehookGroup = QtGui.QGroupBox( _("Personalization scripts, inside chroot") )
        prehooklayout = QtGui.QGridLayout()
        self.prehookList = QtGui.QListWidget()
        preaddHook= QtGui.QPushButton( _("Add") )
        predelHook= QtGui.QPushButton( _("Delete") )
        prehooklayout.addWidget(self.prehookList,0,1,0,1)
        prehookGroup.setLayout(prehooklayout)

        #HOOK disponible
        hookGroup = QtGui.QGroupBox( _("Avalaible personalization scripts") )
        hooklayout = QtGui.QGridLayout()
        self.hookList = QtGui.QListWidget()
        addHook= QtGui.QPushButton( _("Import") )
        self.delHookButton = QtGui.QPushButton( _("Delete") )
        self.delHookButton.setDisabled(1)
        hooklayout.addWidget(self.hookList,0,0,1,0)
        hookGroup.setLayout(hooklayout)

        mainLayout = QtGui.QGridLayout()

        mainLayout.addWidget(hookGroup,0,0,11,2)
        mainLayout.addWidget(addHook,12,0)
        mainLayout.addWidget(self.delHookButton,12,1)
        mainLayout.addWidget(preaddHook,1,3)
        mainLayout.addWidget(predelHook,3,3)
        mainLayout.addWidget(postaddHook,7,3)
        mainLayout.addWidget(postdelHook,9,3)
        mainLayout.addWidget(prehookGroup,0,4,5,4)
        mainLayout.addWidget(posthookGroup,6,4,5,4)

        ##Reading  config file for hook script folder
        
        self.fillList()

       # mainLayout.addWidget(mainhookGroup,0,0)

        QtCore.QObject.connect(preaddHook ,QtCore.SIGNAL('clicked()'),self.addPreHook )
        QtCore.QObject.connect(predelHook ,QtCore.SIGNAL('clicked()'),self.delPreHook )
        QtCore.QObject.connect(self.prehookList,
                               QtCore.SIGNAL('itemDoubleClicked(QListWidgetItem *)'),
                               self.delPreHook )

        QtCore.QObject.connect(postaddHook ,QtCore.SIGNAL('clicked()'),self.addPostHook )
        QtCore.QObject.connect(postdelHook ,QtCore.SIGNAL('clicked()'),self.delPostHook )
        QtCore.QObject.connect(self.posthookList,
                               QtCore.SIGNAL('itemDoubleClicked(QListWidgetItem *)'),
                               self.delPostHook )

        QtCore.QObject.connect(addHook ,QtCore.SIGNAL('clicked()'),self.hookBrowse )
        QtCore.QObject.connect(self.delHookButton ,QtCore.SIGNAL('clicked()'),self.delHook )
        QtCore.QObject.connect(self.hookList ,
                QtCore.SIGNAL('itemSelectionChanged()'),self.delButton )

        self.setLayout(mainLayout)


    def delButton(self):
        """
            Disable del button if an element of the list is selected
        """
        if self.hookList.selectedItems():
            self.delHookButton.setDisabled(0)
        else:
            self.delHookButton.setDisabled(1)


    def initHookSelected(self):
        """
            Initialize selected hook scripts from xml file
        """
        # Test if chroot hook script is in available hook scripts list
        for itemName in self.xmlFile.getHooksList("chroot"):
            # Search item in available hook scripts list
            item = self.hookList.findItems(itemName,QtCore.Qt.MatchExactly)
            if item:
                # Remove package from hook scripts list
                self.hookList.takeItem(self.hookList.row(item[0]))
        # Add packages in chroot hook script list
        self.prehookList.addItems(self.xmlFile.getHooksList("chroot"))

        # Test if binary hook script is in available hook scripts list
        for itemName in self.xmlFile.getHooksList("binary"):
            # Search item in available hook scripts list
            item = self.hookList.findItems(itemName,QtCore.Qt.MatchExactly)
            if item:
                # Remove package from hook scripts list
                self.hookList.takeItem(self.hookList.row(item[0]))
        # Add packages in binary hook script list
        self.posthookList.addItems(self.xmlFile.getHooksList("binary"))



    def hookBrowse(self):
        hookDir = self.livecreatorConfig.get("main","hookdir")
        filenames = QtGui.QFileDialog.getOpenFileNames(self, _("Personalization script import"),
                    QtCore.QString(hookDir),"Script hook (*.sh);;All files (*)") 
        for file in filenames:
            try:
                shutil.copy(str(file), hookDir)
            except Exception, e:
                continue
        self.fillList()

    def addPreHook(self):
        if self.hookList.selectedItems():
            self.prehookList.addItem(self.hookList.takeItem(self.hookList.currentRow()))


    def addPostHook(self):
        if self.hookList.selectedItems():
            self.posthookList.addItem(self.hookList.takeItem(self.hookList.currentRow()))


    def delHook(self):
        """
            Delete hook script from hook script folder and from hook script list
        """
        hookDir = self.livecreatorConfig.get("main","hookdir")
        if self.hookList.selectedItems():
            # Item seleted
            itemSeleted = self.hookList.currentItem().text()
            # Question box
            question = QtGui.QMessageBox( _("Question"),
                    _("Do you really want delete the personalization script named '%s'?") %itemSeleted,
                QtGui.QMessageBox.Question, 
                QtGui.QMessageBox.Yes, 
                QtGui.QMessageBox.No, 
                0 )
            question.setButtonText(QtGui.QMessageBox.Yes, _("&Yes") )
            question.setButtonText(QtGui.QMessageBox.No,_("No") )
            if question.exec_() == QtGui.QMessageBox.Yes:
                # Delete from template folder
                os.remove( "%s/%s"%(hookDir, itemSeleted) )
                # Reload template list
                self.fillList()


    def delPreHook(self):
        if self.prehookList.selectedItems():
            self.hookList.addItem(self.prehookList.takeItem(self.prehookList.currentRow()))


    def delPostHook(self):
        if self.posthookList.selectedItems():
            self.hookList.addItem(self.posthookList.takeItem(self.posthookList.currentRow()))


    def fillList(self):
        self.hookList.clear()
        fileList = functions.readDir(self.livecreatorConfig.get("main","hookdir"))
        for file in fileList:
            item1 = self.posthookList.findItems(file,QtCore.Qt.MatchExactly)
            item2 = self.prehookList.findItems(file,QtCore.Qt.MatchExactly)
            if not item1 and not item2:
                self.hookList.addItem(file)
