#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import sys
from PyQt4 import QtCore, QtGui
from livecreator_misc import functions
import shutil
import os


######################################################
######################################################
######################################################

class SourcePkg(QtGui.QWidget):
    def __init__(self,livecreatorConfig, xmlFile, parent=None):
        QtGui.QWidget.__init__(self, parent)

        self.livecreatorConfig = livecreatorConfig
        self.xmlFile = xmlFile

        #Packages in folder packages

        addPackages = QtGui.QPushButton( _("Import") )
        self.delPackages = QtGui.QPushButton( _("Delete") )
        self.delPackages.setDisabled(1)
        sourceGroup = QtGui.QGroupBox( _("Avalaibles sources packages") )
        self.sourceList = QtGui.QListWidget()
        sourceLayout = QtGui.QVBoxLayout()
        sourceLayout.addWidget(self.sourceList)
        sourceGroup.setLayout(sourceLayout)

        #Packages selected

        self.selectPackage = QtGui.QPushButton( _("Add") )
        self.removePackage = QtGui.QPushButton( _("Delete") )
        sourceSelectedGroup = QtGui.QGroupBox( _("Selected sources packages") )
        self.sourceSelectedList = QtGui.QListWidget()
        sourceSelectedLayout = QtGui.QVBoxLayout()
        sourceSelectedLayout.addWidget(self.sourceSelectedList)
        sourceSelectedGroup.setLayout(sourceSelectedLayout)


        mainLayout = QtGui.QGridLayout()
        mainLayout.addWidget(sourceGroup,0,0,5,2)
        mainLayout.addWidget(addPackages,5,0)
        mainLayout.addWidget(self.delPackages,5,1)
        mainLayout.addWidget(self.selectPackage,1,3)
        mainLayout.addWidget(self.removePackage,3,3)
        mainLayout.addWidget(sourceSelectedGroup,0,4,5,2)
      #  mainLayout.addWidget(buttonsGroup)
        #mainLayout.addSpacing(12)
        #mainLayout.addStretch(1)


        self.fillList()

        #QtCore.QObject.connect(selectPackage ,QtCore.SIGNAL('clicked()'),self.selectPkg )
        #QtCore.QObject.connect(removePackage ,QtCore.SIGNAL('clicked()'),self.removePkg )


        QtCore.QObject.connect(addPackages ,QtCore.SIGNAL('clicked()'),self.pkgBrowse )
        QtCore.QObject.connect(self.delPackages ,QtCore.SIGNAL('clicked()'),self.delpkg )
        QtCore.QObject.connect(self.sourceList ,QtCore.SIGNAL('itemSelectionChanged()'),self.delPkgButton )


        self.setLayout(mainLayout)


    def delPkgButton(self):
        """
            Disable del button if an element of the list is selected
        """
        if self.sourceList.selectedItems():
            self.delPackages.setDisabled(0)
        else:
            self.delPackages.setDisabled(1)


    def fillList(self):
        """
            Rempli la liste dans l'interface qt
        """
        self.sourceList.clear()
        fileList = functions.readDir(self.livecreatorConfig.get("main","pkgdir"),"*.tar.gz")
        #fileList.replaceInStrings(".deb","")
        for file in fileList:
            item = self.sourceSelectedList.findItems(file,QtCore.Qt.MatchExactly)
            if not item:
                self.sourceList.addItem(file)


    def pkgBrowse(self):
        """
            Open a window which contains a browser.
            This browser allow to chose a new package which will be copy
            in template folder.
        """
        pkgDir = self.livecreatorConfig.get("main","pkgdir")
        filenames = QtGui.QFileDialog.getOpenFileNames(self, _("Import sources package"),
                    QtCore.QString(pkgDir),"Package (*.tar.gz)")
        for file in filenames:
            try :
                shutil.copy(str(file), pkgDir)
            except : pass
        self.fillList()


    def delpkg(self):
        """
            Delete source package from package folder and from package list
        """
        pkgDir = self.livecreatorConfig.get("main","pkgdir")
        if self.sourceList.selectedItems():
            # Item seleted
            itemSeleted = self.sourceList.currentItem().text()
            # Question box
            question = QtGui.QMessageBox( _("Question"),
                _("Delete sources package %s ?") %itemSeleted,
                QtGui.QMessageBox.Question, 
                QtGui.QMessageBox.Yes, 
                QtGui.QMessageBox.No, 
                0 )
            question.setButtonText(QtGui.QMessageBox.Yes, _("&Yes") )
            question.setButtonText(QtGui.QMessageBox.No, _("&No") )
            if question.exec_() == QtGui.QMessageBox.Yes:
                # Delete from template folder
                os.remove( "%s/%s"%(pkgDir, itemSeleted) )
                # Reload template list
                self.fillList()


    def initSelectedpkgList(self):
        """
            Initialize selected packages list
        """
        # Test if selected package is in available packages list
        for itemName in self.xmlFile.getSourcesList():
            # Search item in available packages list
            item = self.sourceList.findItems(itemName,QtCore.Qt.MatchExactly)
            if item:
                # Remove package from available packages list
                self.sourceList.takeItem(self.sourceList.row(item[0]))
        # Add packages in selected packages list
        self.sourceSelectedList.addItems(self.xmlFile.getSourcesList())


######################################################
######################################################
######################################################
