#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import sys
from PyQt4 import QtCore, QtGui


class SummaryPkg(QtGui.QWidget):
    def __init__(self, livecreatorConfig, xmlFile, parent=None):
        QtGui.QWidget.__init__(self, parent)

        self.livecreatorConfig = livecreatorConfig
        self.xmlFile = xmlFile

        upstreamPkgGroup = QtGui.QGroupBox(self.tr( _("Official distribution packages") ))
        upstreamPkglayout = QtGui.QVBoxLayout()
        self.upstreamPkgList = QtGui.QListWidget()
        upstreamPkglayout.addWidget(self.upstreamPkgList)
        upstreamPkgGroup.setLayout(upstreamPkglayout)

        localPkgGroup = QtGui.QGroupBox(self.tr( _("Local packages") ))
        localPkglayout = QtGui.QVBoxLayout()
        self.localPkgList = QtGui.QListWidget()
        localPkglayout.addWidget(self.localPkgList)
        localPkgGroup.setLayout(localPkglayout)

###################
###################
###################
        sourceGroup = QtGui.QGroupBox(self.tr( _("Sources packages") ))
        sourcelayout = QtGui.QVBoxLayout()
        self.sourceList = QtGui.QListWidget()
        sourcelayout.addWidget(self.sourceList)
        sourceGroup.setLayout(sourcelayout)
###################
###################
###################

        mainLayout = QtGui.QGridLayout()
        mainLayout.addWidget(upstreamPkgGroup,0,0,2,1)
        mainLayout.addWidget(localPkgGroup,0,1)

###################
###################
###################
        mainLayout.addWidget(sourceGroup,1,1)
###################
###################
###################

        self.setLayout(mainLayout)


    def loadLocalPkgList(self):
        """
            Initialize local pagckages list
        """
        self.localPkgList.addItems(self.xmlFile.getPackagesList("local"))


    def loadUpstreamPkgList(self):
        """
            Initialize local pagckages list
        """
        self.upstreamPkgList.addItems(self.xmlFile.getPackagesList("upstream"))


    def addUpstreamPkg(self, upstreamPkgName):
        """
            add an upstream pagckage in summary list
        """
        self.upstreamPkgList.addItem(upstreamPkgName) 


    def delUpstreamPkg(self, upstreamPkgName):
        """
            add an upstream pagckage in summary list
        """
        if len(self.upstreamPkgList.findItems(upstreamPkgName, QtCore.Qt.MatchExactly)) > 0 :
            item = self.upstreamPkgList.findItems(upstreamPkgName, QtCore.Qt.MatchExactly)[0]
            indexItem = self.upstreamPkgList.row(item)
            self.upstreamPkgList.takeItem(indexItem) 


    def addLocalPkgList(self,localpkg):
        """
            add a local pagckage in summary list
        """
        if localpkg:
            self.localPkgList.addItem(localpkg.text())


    def delLocalPkgList(self,localpkgindex):
        """
            remove a local pagckage in summary list
        """
        self.localPkgList.takeItem(localpkgindex)


###################
###################
###################
    def loadSourcePkgList(self):
        """
            Initialize source pagckages list
        """
        self.sourceList.addItems(self.xmlFile.getSourcesList())


    def addSourcePkgList(self,sourcepkg):
        """
            add a source pagckage in summary list
        """
        if sourcepkg:
            self.sourceList.addItem(sourcepkg.text())


    def delSourcePkgList(self,sourcepkgindex):
        """
            remove a source pagckage in summary list
        """
        self.sourceList.takeItem(sourcepkgindex)
###################
###################
###################
