#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import sys
from PyQt4 import QtCore, QtGui
from livecreator_misc import functions
import os
import subprocess as sp
import time
import re

class genUsbDialog1(QtGui.QMessageBox):
    def __init__(self, parent=None):
        """
            First warning message to be sure that
            user want to make the live
        """
        # self.device Define which device will be use to
        # create the media (ex: /dev/sdb, /dev/cdrom)
        self.device = ""
        # self.deviceName define the name of the usb key detected
        self.deviceName = ""
        QtGui.QMessageBox.__init__(self, _("Create the Live"),
                                    "",
                                    QtGui.QMessageBox.Warning,
                                    QtGui.QMessageBox.Yes,
                                    QtGui.QMessageBox.No,
                                    0)
        self.setWindowTitle( _("Live USB generation") )
        self.setButtonText(QtGui.QMessageBox.Yes,("&Yes") )
        yesButton = self.button(QtGui.QMessageBox.Yes)
        self.setButtonText(QtGui.QMessageBox.No, _("&No") )
        self.setText( _("Please insert USB key...<br>The USB key detection will take some time.") )
        self.clearDmesg()
        #Signals
        QtCore.QObject.connect(yesButton ,QtCore.SIGNAL('clicked()'),self.valid)


    def clearDmesg(self):
        """
            Clear Dmesg to see only  new event
        """
        cmd = "dmesg -c"
        clearDmesg = sp.Popen (cmd,
                     bufsize = 1,
                     shell = True,
                     stdout = sp.PIPE,
                     stderr = sp.STDOUT)
        clearDmesg.stdout.readlines()


    def findDevMount(self,checkOutput):
        """
            Find the USB key name and the devide  on which the usb key is mounted
        """
        for line in checkOutput:
            # Find the USB key name
            if line.find("Direct-Access") != -1:
                # Name found !!!
                # Extract the USB key name
                line = re.sub('[ ]+',' ',line)
                listLine = line.split(" ")
                startIndex = listLine.index("Direct-Access")
                endIndex = listLine.index("PQ:")
                self.deviceName = " ".join(listLine[startIndex+1:endIndex])
                continue
            # Find the device on which the usb key is mounted
            if line.startswith(' sd') and line.endswith('\n'):
                devUsb = line[1:4]
                return devUsb
        return False


    def checkUsb(self):
        """
            For USB check, if a usb key is pluged
        """
        # First Check : just to see if some thing it appends
        cmd = "dmesg -s1"
        time.sleep(2)
        checkUsb = sp.Popen (cmd,
                     bufsize = 1,
                     shell = True,
                     stdout = sp.PIPE,
                     stderr = sp.STDOUT)
        checkOutput = checkUsb.stdout.readlines()
        if checkOutput:
            # Second Check : collect informations
            time.sleep(5)
            cmd = "dmesg -s30"
            checkUsb = sp.Popen (cmd,
                            bufsize = 1,
                            shell = True,
                            stdout = sp.PIPE,
                            stderr = sp.STDOUT)
            checkOutput = checkUsb.stdout.readlines()
            for line in checkOutput:
                # Looking for "usb-storage: device found at" in Dmesg
                if line.startswith('usb-storage: device found at'):
                    # USB FOUND !!! Now search on which /dev/sd? 
                    # the usb key is mounted
                    self.device = self.findDevMount(checkOutput)
                    if self.device:
                        return True
                    else:
                        return False
                else:
                    # test next line
                    continue
            checkUsb.stdout.close()
            return False


    def valid(self):
        """
            Made checks before close the box
        """
        # If yes button is clicked
        if self.checkUsb() :
            self.done(QtGui.QMessageBox.Yes)
        else:
            self.done(-1)


class genUsbDialog2(QtGui.QMessageBox):
    def __init__(self,deviceName, parent=None):
        """
            Second and last message to cancel the
            making of the live
        """
        self.deviceName = deviceName
        QtGui.QMessageBox.__init__(self, _("Create the Live"),
                                    "",
                                    QtGui.QMessageBox.Warning,
                                    QtGui.QMessageBox.Yes,
                                    QtGui.QMessageBox.No,
                                    0)
        self.setWindowTitle( _("USB Live generation") )
        self.setButtonText(QtGui.QMessageBox.Yes, _("&Yes") )
        self.setButtonText(QtGui.QMessageBox.No, _("&No") )
        self.setText( _('''<p align="center">Are you sure that you want use the media %s<b></b> for the generation? <br><br><font color="red"><b>ALL DATA WILL BE ERASED!</b></font><p>''') %self.deviceName)


class genUsbDialog3(QtGui.QMessageBox):
    def __init__(self,device, deviceName, parent=None):
        """
            Second and last message to cancel the
            making of the live
        """
        self.deviceName = deviceName
        self.device = device

        QtGui.QMessageBox.__init__(self, _("Create the Live"),
                                    "",
                                    QtGui.QMessageBox.Warning,
                                    QtGui.QMessageBox.Yes,
                                    QtGui.QMessageBox.No,
                                    0)
        self.setButtonText(QtGui.QMessageBox.Yes, _("&Yes") )
        self.setButtonText(QtGui.QMessageBox.No, _("&No") )
        self.setText( _('''<p align="center">Are you <b>REALLY</b> sure that you want generate Live USB on the <b>%s</b> media mounted on <b>/dev/%s<b>? <br><br><font color="red"><b>ALL DATA OF THE ENTIRE <b>/dev/%s<b> MEDIA WILL BE ERASED!</b></font><p>''') %(self.deviceName,self.device,self.device))


class genUsbProgress(QtGui.QProgressDialog):
    def __init__(self, parent=None):
        """
            Progress bar dialog for bruning CD/DVD
        """
        QtGui.QProgressDialog.__init__(self, parent)
        self.setWindowTitle( _("Live USB Generation") )
        self.setLabelText( _("USB key creation") )
        cancelButton = QtGui.QPushButton("")
        self.setCancelButton(cancelButton)
        cancelButton.hide()
        self.setAutoClose(0)
        #self.setAutoReset(0)
        # Set Progress bar
        #self.bar = QtGui.QProgressBar()
        ##self.setBar(self.bar)
        #self.bar.setValue(10)


    def closeEvent(self, event):
        """
            Don"t close progress bar when
            user click on the X (close)
        """
        event.ignore()



class genUsbSummary(QtGui.QMessageBox):
    def __init__(self, returnProc, parent=None):
        """
            Generate a box which says if the generation
            seems to be ok or not
        """
        QtGui.QMessageBox.__init__(self)
        self.setWindowTitle( _("Live USB Generation") )
        # CD/DVD box
        if returnProc == 0:
            self.setIcon(QtGui.QMessageBox.Information)
            self.setText( _("USB key generation is a success") )
        elif returnProc == 1:
            self.setIcon(QtGui.QMessageBox.Critical)
            self.setText( _("USB key generation has fail") )


