#!/bin/sh

######################################################################
# usplash_theme                                       Michel DEPEIGE #
# 26/03/2008                             michel.depeige@linagora.com #
#                                                                    #
# Description:                                                       #
# Installe une "aleternative" pour un theme usplash, l'active        #
# et met à jour l'initrd                                             #
#                                                                    #
# IN :  [nom du theme]                                               #
# OUT : auto explicatif                                              #
#                                                                    #
#                                                                    #
#--------------------------------------------------------------------#
# Copyright (C) Michel DEPEIGE <mdepeige@linagora.com>               #
# Copyright (C) LINAGORA <http://www.linagora.com>                   #
#                                                                    #
#--------------------------------------------------------------------#
# License: GPLv3                                                     #
#--------------------------------------------------------------------#
# This program is free software; you can redistribute it and/or      #
# modify it under the terms of the GNU General Public License        #
# as published by the Free Software Foundation; either version 2     #
# of the License, or (at your option) any later version.             #
#                                                                    #
# This program is distributed in the hope that it will be useful,    #
# but WITHOUT ANY WARRANTY; without even the implied warranty of     #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
# GNU General Public License for more details.                       #
#                                                                    #
# GPL License: http://www.gnu.org/licenses/gpl.txt                   #
#                                                                    #
#--------------------------------------------------------------------#
# Please visit http://www.linagora.org for other contributions       #
#                                                                    #
#--------------------------------------------------------------------#
# Versions            :                                              #
#    0.1, 26/03/08 - Script initial                                  #
#    0.2, 27/03/08 - support pour $1                                 #
#                                                                    #
#--------------------------------------------------------------------#
# Scripts appelant    : n/a                                          #
# Scripts appeles     : n/a                                          #
# Fichiers en entree  : n/a                                          #
# Fichiers en sortie  : n/a                                          #
#--------------------------------------------------------------------#
######################################################################

### settings

THEME="LiveCreator"

### local utility functions

echo_msg()
{
    echo -n "[+] "
    echo $1
}

echo_error()
{
    echo -n "[E] " >&2
    echo $1 >&2
}


if [ -n "$1" ]
then
    THEME=$1
fi

echo_msg "adding usplash-artwork.so alternative"
update-alternatives --install /usr/lib/usplash/usplash-artwork.so usplash-artwork.so /usr/lib/usplash/usplash-theme-${THEME}.so 10

echo_msg "setting usplash theme"
update-alternatives --set usplash-artwork.so /usr/lib/usplash/usplash-theme-${THEME}.so

echo_msg "updating initrd..."
update-initramfs -u
