#!/bin/sh
######################################################################
# ask_kbd.sh                                          Michel DEPEIGE #
# 03/04/2008                                   mdepeige@linagora.com #
#                                                                    #
# Description:                                                       #
# Boite de dialogue pour la selection de la carte clavier            #
#                                                                    #
# IN :  neant                                                        #
# OUT : auto explicatif                                              #
#                                                                    #
#                                                                    #
#--------------------------------------------------------------------#
# Copyright (C) Michel DEPEIGE <mdepeige@linagora.com>               #
#               Erwan LE GALL <elegall@linagora.com>                 #
# Copyright (C) LINAGORA <http://www.linagora.com>                   #
#                                                                    #
#--------------------------------------------------------------------#
# License: GPLv3                                                     #
#--------------------------------------------------------------------#
# This program is free software; you can redistribute it and/or      #
# modify it under the terms of the GNU General Public License        #
# as published by the Free Software Foundation; either version 2     #
# of the License, or (at your option) any later version.             #
#                                                                    #
# This program is distributed in the hope that it will be useful,    #
# but WITHOUT ANY WARRANTY; without even the implied warranty of     #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
# GNU General Public License for more details.                       #
#                                                                    #
# GPL License: http://www.gnu.org/licenses/gpl.txt                   #
#                                                                    #
#--------------------------------------------------------------------#
# Please visit http://www.linagora.org for other contributions       #
#                                                                    #
#--------------------------------------------------------------------#
# Versions            :                                              #
#    0.2, 04/04/08 - Recupere la liste des cartes                    #
#    0.1, 03/04/08 - Script initial                                  #
#                                                                    #
#--------------------------------------------------------------------#
# Scripts appelant    : n/a                                          #
# Scripts appeles     : n/a                                          #
# Fichiers en entree  : n/a                                          #
# Fichiers en sortie  : stdout                                       #
#--------------------------------------------------------------------#
######################################################################

### functions

set_kbd()
{
	# console
	loadkeys "$1"

	# Change the X keymap
	if [ -f /etc/X11/xorg.conf ]
	then
		sed -i "s/\"XkbLayout\".*$/\"XkbLayout\"   \"${keymap}\"/" /etc/X11/xorg.conf
	fi

	if [ -f /etc/X11/XF86config-4 ]
	then
	        sed -i "s/\"XkbLayout\".*$/\"XkbLayout\"   \"${keymap}\"/" /etc/X11/XF86config-4
	fi

	if [ -f /etc/X11/XF86Config ]
	then
		sed -i "s/\"XkbLayout\".*$/\"XkbLayout\"   \"${keymap}\"/" /etc/X11/XF86Config
	fi
}

### main below

list=`ls -R /usr/share/keymaps/ | grep .kmap | cut -d "." -f 1 | sort | tr "\n" " " | sed -e 's/\ / - /g'`
rm -f /tmp/interactive
dialog --clear --title " Keyboard selection " --menu "Choose your keyboard map in this list" 30 51 24 \
	${list} \
	2>/tmp/interactive

valret=$?
keymap=`cat /tmp/interactive`

case $valret in
	0)	set_kbd "${keymap}" ;;
	1) 	echo "Selecting default mapping" ;;
	255)    echo "Selecting default mapping" ;;
esac

rm -f /tmp/interactive
