#!/bin/sh
######################################################################
# ask_lang.sh                                         Michel DEPEIGE #
# 03/04/2008                                   mdepeige@linagora.com #
#                                                                    #
# Description:                                                       #
# Boite de dialogue pour la selection de la langue                   #
#                                                                    #
# IN :  neant                                                        #
# OUT : auto explicatif                                              #
#                                                                    #
#                                                                    #
#--------------------------------------------------------------------#
# Copyright (C) Michel DEPEIGE <mdepeige@linagora.com>               #
#               Erwan LE GALL <elegall@linagora.com>                 #
# Copyright (C) LINAGORA <http://www.linagora.com>                   #
#                                                                    #
#--------------------------------------------------------------------#
# License: GPLv3                                                     #
#--------------------------------------------------------------------#
# This program is free software; you can redistribute it and/or      #
# modify it under the terms of the GNU General Public License        #
# as published by the Free Software Foundation; either version 2     #
# of the License, or (at your option) any later version.             #
#                                                                    #
# This program is distributed in the hope that it will be useful,    #
# but WITHOUT ANY WARRANTY; without even the implied warranty of     #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
# GNU General Public License for more details.                       #
#                                                                    #
# GPL License: http://www.gnu.org/licenses/gpl.txt                   #
#                                                                    #
#--------------------------------------------------------------------#
# Please visit http://www.linagora.org for other contributions       #
#                                                                    #
#--------------------------------------------------------------------#
# Versions            :                                              #
#    0.2, 18/03/08 - Recuperations de la liste des locales existante #
#    0.1, 17/03/08 - Script initial                                  #
#                                                                    #
#--------------------------------------------------------------------#
# Scripts appelant    : n/a                                          #
# Scripts appeles     : n/a                                          #
# Fichiers en entree  : n/a                                          #
# Fichiers en sortie  : stdout                                       #
#--------------------------------------------------------------------#
######################################################################

change_lang()
{
	cat /usr/share/i18n/SUPPORTED | sed -e 's/^/# /g' > /etc/locale.gen
	# set locales
	sed -i "s/^#\ ${1}\ /${1}\ /" /etc/locale.gen
	/usr/sbin/locale-gen
	
	# shell settings
	export LANG="${1}"
	user="$(grep "Debian Live user" /etc/passwd | cut -d':' -f1)"
	echo "LANG=${1}" >> /home/${user}/.bash_profile
}

### main below

rm -f /tmp/interactive
list=`cat /usr/share/i18n/SUPPORTED | sort | tr "\n" " "`
dialog --clear --title " Language selection " --menu "Choose your language in this list" 20 51 14 \
	${list} \
	2>/tmp/interactive

valret=$?
lang=`cat /tmp/interactive`

case $valret in
	0)	change_lang "${lang}" ;;
	1) 	echo "Selecting default language" ;;
	255)	echo "Selecting default language" ;;
esac

rm -f /tmp/interactive
