#!/bin/sh
######################################################################
# ask_mount.sh                                        Michel DEPEIGE #
# 03/04/2008                                   mdepeige@linagora.com #
#                                                                    #
# Description:                                                       #
# Boite de dialogue pour la selection de la langue                   #
#                                                                    #
# IN :  neant                                                        #
# OUT : auto explicatif                                              #
#                                                                    #
#                                                                    #
#--------------------------------------------------------------------#
# Copyright (C) Michel DEPEIGE <mdepeige@linagora.com>               #
#               Erwan LE GALL <elegall@linagora.com>                 #
# Copyright (C) LINAGORA <http://www.linagora.com>                   #
#                                                                    #
#--------------------------------------------------------------------#
# License: GPLv3                                                     #
#--------------------------------------------------------------------#
# This program is free software; you can redistribute it and/or      #
# modify it under the terms of the GNU General Public License        #
# as published by the Free Software Foundation; either version 2     #
# of the License, or (at your option) any later version.             #
#                                                                    #
# This program is distributed in the hope that it will be useful,    #
# but WITHOUT ANY WARRANTY; without even the implied warranty of     #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
# GNU General Public License for more details.                       #
#                                                                    #
# GPL License: http://www.gnu.org/licenses/gpl.txt                   #
#                                                                    #
#--------------------------------------------------------------------#
# Please visit http://www.linagora.org for other contributions       #
#                                                                    #
#--------------------------------------------------------------------#
# Versions            :                                              #
#    0.1, 17/03/08 - Script initial                                  #
#                                                                    #
#--------------------------------------------------------------------#
# Scripts appelant    : n/a                                          #
# Scripts appeles     : mountall.sh, mountall_forensic.sh            #
# Fichiers en entree  : n/a                                          #
# Fichiers en sortie  : stdout                                       #
#--------------------------------------------------------------------#
######################################################################

rm -f /tmp/interactive
dialog --timeout 10 --clear --title " Mount " --radiolist "Select mount mode: " 10 61 3 \
	"None" "Don't mount any drive" off \
	"Forensic" "Mount drives read-only" \
	on "Full" "Mount drives read-write" off \
	2> /tmp/interactive

choix=`cat /tmp/interactive`
if [ "${choix}" = "Nomount" ]
then
	mount_choice=0
elif [ "${choix}" = "Automount" ]
then
	mount_choice=0
	/etc/init.d/mountall.sh
elif [ "${choix}" = "Forensic" ]
then
	mount_choice=0
	/etc/init.d/mountall_forensic.sh
fi
rm -f /tmp/interactive

