#!/bin/bash

# This script permit to automatically download nessecary packages
# and install a tar.gz passed in parameter

# PACKAGE NECESSITIES :
# Once uncompressed, a tirectory whith EXACTLY the same name, without suffix "tar.gz"
# The tool must be prepared with autotools
# the dependances must be : (list to take from caller script)

# Definition
############
PACKAGES="$(ls /root/packages/*.tar.gz)" 

TAR="/bin/tar"
CP="/bin/cp"

APT="/usr/bin/apt-get --yes --force-yes"
DEPSLIST=""
COMPDEPSLIST="build-essential"

TMP="/tmp"


# Main
###########
${APT} install ${DEPSLIST} ${COMPDEPSLIST}


# Make the sames steps for each package
for package in ${PACKAGES}
do
	package="$(basename ${package})"
	# Create a well environnment
	$CP /root/packages/${package} ${TMP}
	cd ${TMP}

	# Uncompress
	${TAR} xvzf ${package}
	cd ${package/\.tar\.gz/}

	# Follow classical way installation
	./configure
	make
	make install

	cd -
done

# clean building environment
${APT} remove --purge ${COMPDEPSLIST}
