#!/bin/bash

# DON'T EXECUTE THIS IF YOU ARE NOT INSIDE A CHROOT

######################################################################
# disable-services                                    Michel Depeige #
# 17/03/2008                                   mdepeige@linagora.com #
#                                                                    #
# Description:                                                       #
# Desactive les daemons du runlevel 4                                #
# + le reseau sur /etc/rcS.d                                         #
#                                                                    #
# IN :  neanti                                                       #
# OUT : auto explicatif                                              #
#                                                                    #
#                                                                    #
#--------------------------------------------------------------------#
# Copyright (C) Michel DEPEIGE <mdepeige@linagora.com>               #
# Copyright (C) LINAGORA <http://www.linagora.com>                   #
#                                                                    #
#--------------------------------------------------------------------#
# License: GPLv3                                                     #
#--------------------------------------------------------------------#
# This program is free software; you can redistribute it and/or      #
# modify it under the terms of the GNU General Public License        #
# as published by the Free Software Foundation; either version 2     #
# of the License, or (at your option) any later version.             #
#                                                                    #
# This program is distributed in the hope that it will be useful,    #
# but WITHOUT ANY WARRANTY; without even the implied warranty of     #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      #
# GNU General Public License for more details.                       #
#                                                                    #
# GPL License: http://www.gnu.org/licenses/gpl.txt                   #
#                                                                    #
#--------------------------------------------------------------------#
# Please visit http://www.linagora.org for other contributions       #
#                                                                    #
#--------------------------------------------------------------------#
# Versions            :                                              #
#    0.1, 17/03/08 - Script initial                                  #
#                                                                    #
#--------------------------------------------------------------------#
# Scripts appelant    : n/a                                          #
# Scripts appeles     : n/a                                          #
# Fichiers en entree  : n/a                                          #
# Fichiers en sortie  : stdout                                       #
#--------------------------------------------------------------------#
######################################################################

### local utility functions

echo_msg()
{
	echo -n "[+] "
	echo $1
}

echo_error()
{
	echo -n "[E] " >&2
	echo $1 >&2
}	

disable_service()
{
	echo -n "[D] disabling $1... "
	d=${s:1}
	d="K$d"
	mv $s $d > /dev/null
	echo "done"
}

### main

echo_msg "disabling network from rcS"
cd /etc/rcS.d/ > /dev/null
for s in *networking
do
	disable_service $s
done
cd - > /dev/null
