#!/bin/sh

### local utility functions

echo_msg()
{
	echo -n "[+] "
	echo $1
}

echo_error()
{
	echo -n "[E] " >&2
	echo $1 >&2
}	

### main
# Change initrd
cd binary/live/
echo_msg "Working on initrd..."
gunzip -S ".img" initrd1.img

mkdir -p conf

echo "unix" > conf/modules
echo "loop" >> conf/modules
echo "cryptoloop" >> conf/modules
echo "aes" >> conf/modules

chmod 644 conf/modules

echo_msg `echo "conf/modules" | cpio -o -A -H newc -O initrd1`

#change keyboard layout
cpio -id init < initrd1
sed -i 's|export ROOT=|export ROOT=\n/bin/loadkeys /usr/boot_kmap.gz|' init
# Libs need by loadkeys
mkdir -p lib/
cp /lib/libcfont.so.0.0.0   lib/libcfont.so.0
cp /lib/libctutils.so.0.0.0 lib/libctutils.so.0
cp /lib/libconsole.so.0.0.0 lib/libconsole.so.0
# Files need by loadkeys
mkdir -p usr/share/keymaps/i386/include
cp /usr/share/keymaps/i386/include/* usr/share/keymaps/i386/include/
# Keymaps chosen
mkdir -p usr/
cp /tmp/boot_kmap.gz usr/

echo_msg `echo "init" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "/bin/loadkeys" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "lib/libcfont.so.0" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "lib/libctutils.so.0" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "lib/libconsole.so.0" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/azerty-layout.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/backspace.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/ctrl.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/euro.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/keypad.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/linux-keys-bare.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/linux-keys-extd.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/linux-with-alt-and-altgr.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/linux-with-modeshift-altgr.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/linux-with-two-alt-keys.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/mac-linux-keys-bare.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/qwerty-layout.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/qwertz-layout.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/share/keymaps/i386/include/windowkeys.inc.gz" | cpio -o -A -H newc -O initrd1`
echo_msg `echo "usr/boot_kmap.gz" | cpio -o -A -H newc -O initrd1`

mv initrd1 initrd1.img
gzip initrd1.img
mv initrd1.img.gz initrd1.img

echo_msg "Cleaning up..."
rm -rf scripts/init-premount

cd -
